/*
**  MMXmem benchmarks for RAMspeed (i386)
**
**  (Win32 release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2004-05 Rhett M. Hollander <rhett@alasir.com>
**  Copyright (c) 2006-09 Paul V. Bolotoff <walter@alasir.com>
**
**  All rights reserved.
**
*/

.globl  _mmxcp
_mmxcp:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate memory; 4Kb page alignment enabled */
	movl	$0x00001000, %ebp
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebp, %ecx
	movl	%ecx, 0(%esp)
	call	_malloc
	movl	%eax, 28(%esp)
	addl	%ebp, %eax
	andw	$0xF000, %ax
	movl	%eax, %esi
	addl	%ebx, %eax
	movl	%eax, %edi
/* prefill */
	movl	$0x00210021, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm0
	movl	%ebx, %ecx
	shrl	$5, %ecx
	movl	%esi, %edx
.precp:
	movq	%mm0, 0(%edx)
	movq	%mm0, 8(%edx)
	movq	%mm0, 16(%edx)
	movq	%mm0, 24(%edx)
	addl	$32, %edx
	loopl	.precp
/* counter (start); stack sanity enabled */
	movl	%esp, %ebp
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebp, %esp
/* execute */
	shrl	$8, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, %edx
	movl	%edi, %ebp
.maincp:
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	movq	%mm0, 0(%edi)
	movq	%mm1, 8(%edi)
	movq	%mm2, 16(%edi)
	movq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	movq	%mm0, 32(%edi)
	movq	%mm1, 40(%edi)
	movq	%mm2, 48(%edi)
	movq	%mm3, 56(%edi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	movq	%mm0, 64(%edi)
	movq	%mm1, 72(%edi)
	movq	%mm2, 80(%edi)
	movq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	movq	%mm0, 96(%edi)
	movq	%mm1, 104(%edi)
	movq	%mm2, 112(%edi)
	movq	%mm3, 120(%edi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	movq	%mm0, 128(%edi)
	movq	%mm1, 136(%edi)
	movq	%mm2, 144(%edi)
	movq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	movq	%mm0, 160(%edi)
	movq	%mm1, 168(%edi)
	movq	%mm2, 176(%edi)
	movq	%mm3, 184(%edi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	movq	%mm0, 192(%edi)
	movq	%mm1, 200(%edi)
	movq	%mm2, 208(%edi)
	movq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	movq	%mm0, 224(%edi)
	movq	%mm1, 232(%edi)
	movq	%mm2, 240(%edi)
	movq	%mm3, 248(%edi)
	addl	$256, %esi
	addl	$256, %edi
	decl	%ebx
	jnz	.maincp

	movl	%ecx, %ebx
	movl	%edx, %esi
	movl	%ebp, %edi
	decl	%eax
	jnz	.maincp

/* counter (finish); stack sanity enabled */
	movl	%esp, %ebp
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebp, %esp
/* free memory */
	movl	28(%esp), %eax
	movl	%eax, 0(%esp)
	call	_free
/* counter (base frequency); stack sanity enabled */
	movl	%esp, %ebp
	leal	24(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceFrequency@4
	movl	%ebp, %esp
/* time calculation (in milliseconds) */
	movl	24(%esp), %eax
	movl	28(%esp), %edx
	movl	$1000, %ecx
	divl	%ecx
	movl	%eax, %ecx
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	44(%esp), %edx
	sbbl	36(%esp), %edx
	divl	%ecx
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  _mmxsc
_mmxsc:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate memory; 4Kb page alignment enabled */
	movl	$0x00001000, %ebp
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebp, %ecx
	movl	%ecx, 0(%esp)
	call	_malloc
	movl	%eax, 28(%esp)
	addl	%ebp, %eax
	andw	$0xF000, %ax
	movl	%eax, %esi
	addl	%ebx, %eax
	movl	%eax, %edi
/* prefill */
	movl	$0x00210021, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm0
	movl	%ebx, %ecx
	shrl	$5, %ecx
	movl	%esi, %edx
.presc:
	movq	%mm0, 0(%edx)
	movq	%mm0, 8(%edx)
	movq	%mm0, 16(%edx)
	movq	%mm0, 24(%edx)
	addl	$32, %edx
	loopl	.presc
/* counter (start); stack sanity enabled */
	movl	%esp, %ebp
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebp, %esp
/* create the multiplier */
	movw	$77, 8(%esp)
	movw	$77, 10(%esp)
	movw	$77, 12(%esp)
	movw	$77, 14(%esp)
	movq	8(%esp), %mm4
/* execute */
	shrl	$8, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, %edx
	movl	%edi, %ebp
.mainsc:
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 0(%edi)
	movq	%mm1, 8(%edi)
	movq	%mm2, 16(%edi)
	movq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 32(%edi)
	movq	%mm1, 40(%edi)
	movq	%mm2, 48(%edi)
	movq	%mm3, 56(%edi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 64(%edi)
	movq	%mm1, 72(%edi)
	movq	%mm2, 80(%edi)
	movq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 96(%edi)
	movq	%mm1, 104(%edi)
	movq	%mm2, 112(%edi)
	movq	%mm3, 120(%edi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 128(%edi)
	movq	%mm1, 136(%edi)
	movq	%mm2, 144(%edi)
	movq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 160(%edi)
	movq	%mm1, 168(%edi)
	movq	%mm2, 176(%edi)
	movq	%mm3, 184(%edi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 192(%edi)
	movq	%mm1, 200(%edi)
	movq	%mm2, 208(%edi)
	movq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 224(%edi)
	movq	%mm1, 232(%edi)
	movq	%mm2, 240(%edi)
	movq	%mm3, 248(%edi)
	addl	$256, %esi
	addl	$256, %edi
	decl	%ebx
	jnz	.mainsc

	movl	%ecx, %ebx
	movl	%edx, %esi
	movl	%ebp, %edi
	decl	%eax
	jnz	.mainsc

/* counter (finish); stack sanity enabled */
	movl	%esp, %ebp
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebp, %esp
/* free memory */
	movl	28(%esp), %eax
	movl	%eax, 0(%esp)
	call	_free
/* counter (base frequency); stack sanity enabled */
	movl	%esp, %ebp
	leal	24(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceFrequency@4
	movl	%ebp, %esp
/* time calculation (in milliseconds) */
	movl	24(%esp), %eax
	movl	28(%esp), %edx
	movl	$1000, %ecx
	divl	%ecx
	movl	%eax, %ecx
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	44(%esp), %edx
	sbbl	36(%esp), %edx
	divl	%ecx
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  _mmxad
_mmxad:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate memory; 4Kb page alignment enabled */
	movl	$0x00001000, %ebp
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebp, %ecx
	movl	%ecx, 0(%esp)
	call	_malloc
	movl	%eax, 28(%esp)
	addl	%ebp, %eax
	andw	$0xF000, %ax
	movl	%eax, %esi
	addl	%ebx, %eax
	movl	%eax, %ebp
	addl	%ebx, %eax
	movl	%eax, %edi
/* prefill */
	movl	$0x00210021, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm0
	movl	$0x00370037, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm1
	movl	%ebx, %ecx
	shrl	$5, %ecx
	movl	%esi, %edx
	movl	%ebp, %eax
.pread:
	movq	%mm0, 0(%edx)
	movq	%mm0, 8(%edx)
	movq	%mm0, 16(%edx)
	movq	%mm0, 24(%edx)
	movq	%mm1, 0(%eax)
	movq	%mm1, 8(%eax)
	movq	%mm1, 16(%eax)
	movq	%mm1, 24(%eax)
	addl	$32, %edx
	addl	$32, %eax
	loopl	.pread
/* counter (start); stack sanity enabled */
	movl	%esp, %ebx
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebx, %esp
/* execute */
	movl	68(%esp), %ebx
	shll	$2, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, 8(%esp)
	movl	%ebp, 12(%esp)
	movl	%edi, 16(%esp)
	movl	$256, %edx
.mainad:
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	paddusw	0(%ebp), %mm0
	paddusw	8(%ebp), %mm1
	paddusw	16(%ebp), %mm2
	paddusw	24(%ebp), %mm3
	movq	%mm0, 0(%edi)
	movq	%mm1, 8(%edi)
	movq	%mm2, 16(%edi)
	movq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	paddusw	32(%ebp), %mm0
	paddusw	40(%ebp), %mm1
	paddusw	48(%ebp), %mm2
	paddusw	56(%ebp), %mm3
	movq	%mm0, 32(%edi)
	movq	%mm1, 40(%edi)
	movq	%mm2, 48(%edi)
	movq	%mm3, 56(%edi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	paddusw	64(%ebp), %mm0
	paddusw	72(%ebp), %mm1
	paddusw	80(%ebp), %mm2
	paddusw	88(%ebp), %mm3
	movq	%mm0, 64(%edi)
	movq	%mm1, 72(%edi)
	movq	%mm2, 80(%edi)
	movq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	paddusw	96(%ebp), %mm0
	paddusw	104(%ebp), %mm1
	paddusw	112(%ebp), %mm2
	paddusw	120(%ebp), %mm3
	movq	%mm0, 96(%edi)
	movq	%mm1, 104(%edi)
	movq	%mm2, 112(%edi)
	movq	%mm3, 120(%edi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	paddusw	128(%ebp), %mm0
	paddusw	136(%ebp), %mm1
	paddusw	144(%ebp), %mm2
	paddusw	152(%ebp), %mm3
	movq	%mm0, 128(%edi)
	movq	%mm1, 136(%edi)
	movq	%mm2, 144(%edi)
	movq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	paddusw	160(%ebp), %mm0
	paddusw	168(%ebp), %mm1
	paddusw	176(%ebp), %mm2
	paddusw	184(%ebp), %mm3
	movq	%mm0, 160(%edi)
	movq	%mm1, 168(%edi)
	movq	%mm2, 176(%edi)
	movq	%mm3, 184(%edi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	paddusw	192(%ebp), %mm0
	paddusw	200(%ebp), %mm1
	paddusw	208(%ebp), %mm2
	paddusw	216(%ebp), %mm3
	movq	%mm0, 192(%edi)
	movq	%mm1, 200(%edi)
	movq	%mm2, 208(%edi)
	movq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	paddusw	224(%ebp), %mm0
	paddusw	232(%ebp), %mm1
	paddusw	240(%ebp), %mm2
	paddusw	248(%ebp), %mm3
	movq	%mm0, 224(%edi)
	movq	%mm1, 232(%edi)
	movq	%mm2, 240(%edi)
	movq	%mm3, 248(%edi)
	addl	%edx, %esi
	addl	%edx, %ebp
	addl	%edx, %edi
	decl	%ebx
	jnz	.mainad

	movl	%ecx, %ebx
	movl	8(%esp), %esi
	movl	12(%esp), %ebp
	movl	16(%esp), %edi
	decl	%eax
	jnz	.mainad

/* counter (finish); stack sanity enabled */
	movl	%esp, %ebx
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebx, %esp
/* free memory */
	movl	28(%esp), %eax
	movl	%eax, 0(%esp)
	call	_free
/* counter (base frequency); stack sanity enabled */
	movl	%esp, %ebx
	leal	24(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceFrequency@4
	movl	%ebx, %esp
/* time calculation (in milliseconds) */
	movl	24(%esp), %eax
	movl	28(%esp), %edx
	movl	$1000, %ecx
	divl	%ecx
	movl	%eax, %ecx
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	44(%esp), %edx
	sbbl	36(%esp), %edx
	divl	%ecx
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  _mmxtr
_mmxtr:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate memory; 4Kb page alignment enabled */
	movl	$0x00001000, %ebp
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebp, %ecx
	movl	%ecx, 0(%esp)
	call	_malloc
	movl	%eax, 28(%esp)
	addl	%ebp, %eax
	andw	$0xF000, %ax
	movl	%eax, %esi
	addl	%ebx, %eax
	movl	%eax, %ebp
	addl	%ebx, %eax
	movl	%eax, %edi
/* prefill */
	movl	$0x00210021, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm0
	movl	$0x00370037, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm1
	movl	%ebx, %ecx
	shrl	$5, %ecx
	movl	%esi, %edx
	movl	%ebp, %eax
.pretr:
	movq	%mm0, 0(%edx)
	movq	%mm0, 8(%edx)
	movq	%mm0, 16(%edx)
	movq	%mm0, 24(%edx)
	movq	%mm1, 0(%eax)
	movq	%mm1, 8(%eax)
	movq	%mm1, 16(%eax)
	movq	%mm1, 24(%eax)
	addl	$32, %edx
	addl	$32, %eax
	loopl	.pretr
/* counter (start); stack sanity enabled */
	movl	%esp, %ebx
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebx, %esp
/* create the multiplier */
	movw	$77, 8(%esp)
	movw	$77, 10(%esp)
	movw	$77, 12(%esp)
	movw	$77, 14(%esp)
	movq	8(%esp), %mm4
/* execute */
	movl	68(%esp), %ebx
	shll	$2, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, 8(%esp)
	movl	%ebp, 12(%esp)
	movl	%edi, 16(%esp)
	movl	$256, %edx
.maintr:
	movq	0(%ebp), %mm0
	movq	8(%ebp), %mm1
	movq	16(%ebp), %mm2
	movq	24(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	0(%esi), %mm0
	paddusw	8(%esi), %mm1
	paddusw	16(%esi), %mm2
	paddusw	24(%esi), %mm3
	movq	%mm0, 0(%edi)
	movq	%mm1, 8(%edi)
	movq	%mm2, 16(%edi)
	movq	%mm3, 24(%edi)
	movq	32(%ebp), %mm0
	movq	40(%ebp), %mm1
	movq	48(%ebp), %mm2
	movq	56(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	32(%esi), %mm0
	paddusw	40(%esi), %mm1
	paddusw	48(%esi), %mm2
	paddusw	56(%esi), %mm3
	movq	%mm0, 32(%edi)
	movq	%mm1, 40(%edi)
	movq	%mm2, 48(%edi)
	movq	%mm3, 56(%edi)
	movq	64(%ebp), %mm0
	movq	72(%ebp), %mm1
	movq	80(%ebp), %mm2
	movq	88(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	64(%esi), %mm0
	paddusw	72(%esi), %mm1
	paddusw	80(%esi), %mm2
	paddusw	88(%esi), %mm3
	movq	%mm0, 64(%edi)
	movq	%mm1, 72(%edi)
	movq	%mm2, 80(%edi)
	movq	%mm3, 88(%edi)
	movq	96(%ebp), %mm0
	movq	104(%ebp), %mm1
	movq	112(%ebp), %mm2
	movq	120(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	96(%esi), %mm0
	paddusw	104(%esi), %mm1
	paddusw	112(%esi), %mm2
	paddusw	120(%esi), %mm3
	movq	%mm0, 96(%edi)
	movq	%mm1, 104(%edi)
	movq	%mm2, 112(%edi)
	movq	%mm3, 120(%edi)
	movq	128(%ebp), %mm0
	movq	136(%ebp), %mm1
	movq	144(%ebp), %mm2
	movq	152(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	128(%esi), %mm0
	paddusw	136(%esi), %mm1
	paddusw	144(%esi), %mm2
	paddusw	152(%esi), %mm3
	movq	%mm0, 128(%edi)
	movq	%mm1, 136(%edi)
	movq	%mm2, 144(%edi)
	movq	%mm3, 152(%edi)
	movq	160(%ebp), %mm0
	movq	168(%ebp), %mm1
	movq	176(%ebp), %mm2
	movq	184(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	160(%esi), %mm0
	paddusw	168(%esi), %mm1
	paddusw	176(%esi), %mm2
	paddusw	184(%esi), %mm3
	movq	%mm0, 160(%edi)
	movq	%mm1, 168(%edi)
	movq	%mm2, 176(%edi)
	movq	%mm3, 184(%edi)
	movq	192(%ebp), %mm0
	movq	200(%ebp), %mm1
	movq	208(%ebp), %mm2
	movq	216(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	192(%esi), %mm0
	paddusw	200(%esi), %mm1
	paddusw	208(%esi), %mm2
	paddusw	216(%esi), %mm3
	movq	%mm0, 192(%edi)
	movq	%mm1, 200(%edi)
	movq	%mm2, 208(%edi)
	movq	%mm3, 216(%edi)
	movq	224(%ebp), %mm0
	movq	232(%ebp), %mm1
	movq	240(%ebp), %mm2
	movq	248(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	224(%esi), %mm0
	paddusw	232(%esi), %mm1
	paddusw	240(%esi), %mm2
	paddusw	248(%esi), %mm3
	movq	%mm0, 224(%edi)
	movq	%mm1, 232(%edi)
	movq	%mm2, 240(%edi)
	movq	%mm3, 248(%edi)
	addl	%edx, %esi
	addl	%edx, %ebp
	addl	%edx, %edi
	decl	%ebx
	jnz	.maintr

	movl	%ecx, %ebx
	movl	8(%esp), %esi
	movl	12(%esp), %ebp
	movl	16(%esp), %edi
	decl	%eax
	jnz	.maintr

/* counter (finish); stack sanity enabled */
	movl	%esp, %ebx
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebx, %esp
/* free memory */
	movl	28(%esp), %eax
	movl	%eax, 0(%esp)
	call	_free
/* counter (base frequency); stack sanity enabled */
	movl	%esp, %ebx
	leal	24(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceFrequency@4
	movl	%ebx, %esp
/* time calculation (in milliseconds) */
	movl	24(%esp), %eax
	movl	28(%esp), %edx
	movl	$1000, %ecx
	divl	%ecx
	movl	%eax, %ecx
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	44(%esp), %edx
	sbbl	36(%esp), %edx
	divl	%ecx
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  _mmxcp_nt
_mmxcp_nt:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate memory; 4Kb page alignment enabled */
	movl	$0x00001000, %ebp
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebp, %ecx
	movl	%ecx, 0(%esp)
	call	_malloc
	movl	%eax, 28(%esp)
	addl	%ebp, %eax
	andw	$0xF000, %ax
	movl	%eax, %esi
	addl	%ebx, %eax
	movl	%eax, %edi
/* prefill */
	movl	$0x00210021, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm0
	movl	%ebx, %ecx
	shrl	$5, %ecx
	movl	%esi, %edx
.precp_nt:
	movntq	%mm0, 0(%edx)
	movntq	%mm0, 8(%edx)
	movntq	%mm0, 16(%edx)
	movntq	%mm0, 24(%edx)
	addl	$32, %edx
	loopl	.precp_nt
/* counter (start); stack sanity enabled */
	movl	%esp, %ebp
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebp, %esp
/* execute */
	shrl	$8, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, %edx
	movl	%edi, %ebp
.maincp_nt:
/* every loop prefetches the next one */
	prefetchnta	256(%esi)
	prefetchnta	288(%esi)
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	prefetchnta	320(%esi)
	prefetchnta	352(%esi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	prefetchnta	384(%esi)
	prefetchnta	416(%esi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	prefetchnta	448(%esi)
	prefetchnta	480(%esi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)
	addl	$256, %esi
	addl	$256, %edi
	decl	%ebx
	jnz	.maincp_nt

/* the last loop of the memory block;
 * no more prefetches to avoid hidden page faults */
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)

	movl	%ecx, %ebx
	movl	%edx, %esi
	movl	%ebp, %edi
	decl	%eax
	jnz	.maincp_nt

/* counter (finish); stack sanity enabled */
	movl	%esp, %ebp
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebp, %esp
/* free memory */
	movl	28(%esp), %eax
	movl	%eax, 0(%esp)
	call	_free
/* counter (base frequency); stack sanity enabled */
	movl	%esp, %ebp
	leal	24(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceFrequency@4
	movl	%ebp, %esp
/* time calculation (in milliseconds) */
	movl	24(%esp), %eax
	movl	28(%esp), %edx
	movl	$1000, %ecx
	divl	%ecx
	movl	%eax, %ecx
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	44(%esp), %edx
	sbbl	36(%esp), %edx
	divl	%ecx
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  _mmxsc_nt
_mmxsc_nt:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate memory; 4Kb page alignment enabled */
	movl	$0x00001000, %ebp
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebp, %ecx
	movl	%ecx, 0(%esp)
	call	_malloc
	movl	%eax, 28(%esp)
	addl	%ebp, %eax
	andw	$0xF000, %ax
	movl	%eax, %esi
	addl	%ebx, %eax
	movl	%eax, %edi
/* prefill */
	movl	$0x00210021, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm0
	movl	%ebx, %ecx
	shrl	$5, %ecx
	movl	%esi, %edx
.presc_nt:
	movntq	%mm0, 0(%edx)
	movntq	%mm0, 8(%edx)
	movntq	%mm0, 16(%edx)
	movntq	%mm0, 24(%edx)
	addl	$32, %edx
	loopl	.presc_nt
/* counter (start); stack sanity enabled */
	movl	%esp, %ebp
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebp, %esp
/* create the multiplier */
	movw	$77, 8(%esp)
	movw	$77, 10(%esp)
	movw	$77, 12(%esp)
	movw	$77, 14(%esp)
	movq	8(%esp), %mm4
/* execute */
	shrl	$8, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, %edx
	movl	%edi, %ebp
.mainsc_nt:
/* every loop prefetches the next one */
	prefetchnta	256(%esi)
	prefetchnta	288(%esi)
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	prefetchnta	320(%esi)
	prefetchnta	352(%esi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	prefetchnta	384(%esi)
	prefetchnta	416(%esi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	prefetchnta	448(%esi)
	prefetchnta	480(%esi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)
	addl	$256, %esi
	addl	$256, %edi
	decl	%ebx
	jnz	.mainsc_nt

/* the last loop of the memory block;
 * no more prefetches to avoid hidden page faults */
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)

	movl	%ecx, %ebx
	movl	%edx, %esi
	movl	%ebp, %edi
	decl	%eax
	jnz	.mainsc_nt

/* counter (finish); stack sanity enabled */
	movl	%esp, %ebp
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebp, %esp
/* free memory */
	movl	28(%esp), %eax
	movl	%eax, 0(%esp)
	call	_free
/* counter (base frequency); stack sanity enabled */
	movl	%esp, %ebp
	leal	24(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceFrequency@4
	movl	%ebp, %esp
/* time calculation (in milliseconds) */
	movl	24(%esp), %eax
	movl	28(%esp), %edx
	movl	$1000, %ecx
	divl	%ecx
	movl	%eax, %ecx
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	44(%esp), %edx
	sbbl	36(%esp), %edx
	divl	%ecx
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  _mmxad_nt
_mmxad_nt:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate memory; 4Kb page alignment enabled */
	movl	$0x00001000, %ebp
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebp, %ecx
	movl	%ecx, 0(%esp)
	call	_malloc
	movl	%eax, 28(%esp)
	addl	%ebp, %eax
	andw	$0xF000, %ax
	movl	%eax, %esi
	addl	%ebx, %eax
	movl	%eax, %ebp
	addl	%ebx, %eax
	movl	%eax, %edi
/* prefill */
	movl	$0x00210021, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm0
	movl	$0x00370037, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm1
	movl	%ebx, %ecx
	shrl	$5, %ecx
	movl	%esi, %edx
	movl	%ebp, %eax
.pread_nt:
	movntq	%mm0, 0(%edx)
	movntq	%mm0, 8(%edx)
	movntq	%mm0, 16(%edx)
	movntq	%mm0, 24(%edx)
	movntq	%mm1, 0(%eax)
	movntq	%mm1, 8(%eax)
	movntq	%mm1, 16(%eax)
	movntq	%mm1, 24(%eax)
	addl	$32, %edx
	addl	$32, %eax
	loopl	.pread_nt
/* counter (start); stack sanity enabled */
	movl	%esp, %ebx
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebx, %esp
/* execute */
	movl	68(%esp), %ebx
	shll	$2, %ebx
	decl	%ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, 8(%esp)
	movl	%ebp, 12(%esp)
	movl	%edi, 16(%esp)
	movl	$256, %edx
.mainad_nt:
/* every loop prefetches the next one */
	prefetchnta	256(%ebp)
	prefetchnta	288(%ebp)
	movq	0(%ebp), %mm0
	movq	8(%ebp), %mm1
	movq	16(%ebp), %mm2
	movq	24(%ebp), %mm3
	paddusw	0(%esi), %mm0
	paddusw	8(%esi), %mm1
	paddusw	16(%esi), %mm2
	paddusw	24(%esi), %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	prefetchnta	256(%esi)
	prefetchnta	288(%esi)
	movq	32(%ebp), %mm0
	movq	40(%ebp), %mm1
	movq	48(%ebp), %mm2
	movq	56(%ebp), %mm3
	paddusw	32(%esi), %mm0
	paddusw	40(%esi), %mm1
	paddusw	48(%esi), %mm2
	paddusw	56(%esi), %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	prefetchnta	320(%ebp)
	prefetchnta	352(%ebp)
	movq	64(%ebp), %mm0
	movq	72(%ebp), %mm1
	movq	80(%ebp), %mm2
	movq	88(%ebp), %mm3
	paddusw	64(%esi), %mm0
	paddusw	72(%esi), %mm1
	paddusw	80(%esi), %mm2
	paddusw	88(%esi), %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	prefetchnta	320(%esi)
	prefetchnta	352(%esi)
	movq	96(%ebp), %mm0
	movq	104(%ebp), %mm1
	movq	112(%ebp), %mm2
	movq	120(%ebp), %mm3
	paddusw	96(%esi), %mm0
	paddusw	104(%esi), %mm1
	paddusw	112(%esi), %mm2
	paddusw	120(%esi), %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	prefetchnta	384(%ebp)
	prefetchnta	416(%ebp)
	movq	128(%ebp), %mm0
	movq	136(%ebp), %mm1
	movq	144(%ebp), %mm2
	movq	152(%ebp), %mm3
	paddusw	128(%esi), %mm0
	paddusw	136(%esi), %mm1
	paddusw	144(%esi), %mm2
	paddusw	152(%esi), %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	prefetchnta	384(%esi)
	prefetchnta	416(%esi)
	movq	160(%ebp), %mm0
	movq	168(%ebp), %mm1
	movq	176(%ebp), %mm2
	movq	184(%ebp), %mm3
	paddusw	160(%esi), %mm0
	paddusw	168(%esi), %mm1
	paddusw	176(%esi), %mm2
	paddusw	184(%esi), %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	prefetchnta	448(%ebp)
	prefetchnta	480(%ebp)
	movq	192(%ebp), %mm0
	movq	200(%ebp), %mm1
	movq	208(%ebp), %mm2
	movq	216(%ebp), %mm3
	paddusw	192(%esi), %mm0
	paddusw	200(%esi), %mm1
	paddusw	208(%esi), %mm2
	paddusw	216(%esi), %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	prefetchnta	448(%esi)
	prefetchnta	480(%esi)
	movq	224(%ebp), %mm0
	movq	232(%ebp), %mm1
	movq	240(%ebp), %mm2
	movq	248(%ebp), %mm3
	paddusw	224(%esi), %mm0
	paddusw	232(%esi), %mm1
	paddusw	240(%esi), %mm2
	paddusw	248(%esi), %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)
	addl	%edx, %esi
	addl	%edx, %ebp
	addl	%edx, %edi
	decl	%ebx
	jnz	.mainad_nt

/* the last loop of the memory block;
 * no more prefetches to avoid hidden page faults */
	movq	0(%ebp), %mm0
	movq	8(%ebp), %mm1
	movq	16(%ebp), %mm2
	movq	24(%ebp), %mm3
	paddusw	0(%esi), %mm0
	paddusw	8(%esi), %mm1
	paddusw	16(%esi), %mm2
	paddusw	24(%esi), %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	movq	32(%ebp), %mm0
	movq	40(%ebp), %mm1
	movq	48(%ebp), %mm2
	movq	56(%ebp), %mm3
	paddusw	32(%esi), %mm0
	paddusw	40(%esi), %mm1
	paddusw	48(%esi), %mm2
	paddusw	56(%esi), %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	movq	64(%ebp), %mm0
	movq	72(%ebp), %mm1
	movq	80(%ebp), %mm2
	movq	88(%ebp), %mm3
	paddusw	64(%esi), %mm0
	paddusw	72(%esi), %mm1
	paddusw	80(%esi), %mm2
	paddusw	88(%esi), %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	movq	96(%ebp), %mm0
	movq	104(%ebp), %mm1
	movq	112(%ebp), %mm2
	movq	120(%ebp), %mm3
	paddusw	96(%esi), %mm0
	paddusw	104(%esi), %mm1
	paddusw	112(%esi), %mm2
	paddusw	120(%esi), %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	movq	128(%ebp), %mm0
	movq	136(%ebp), %mm1
	movq	144(%ebp), %mm2
	movq	152(%ebp), %mm3
	paddusw	128(%esi), %mm0
	paddusw	136(%esi), %mm1
	paddusw	144(%esi), %mm2
	paddusw	152(%esi), %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	movq	160(%ebp), %mm0
	movq	168(%ebp), %mm1
	movq	176(%ebp), %mm2
	movq	184(%ebp), %mm3
	paddusw	160(%esi), %mm0
	paddusw	168(%esi), %mm1
	paddusw	176(%esi), %mm2
	paddusw	184(%esi), %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	movq	192(%ebp), %mm0
	movq	200(%ebp), %mm1
	movq	208(%ebp), %mm2
	movq	216(%ebp), %mm3
	paddusw	192(%esi), %mm0
	paddusw	200(%esi), %mm1
	paddusw	208(%esi), %mm2
	paddusw	216(%esi), %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	movq	224(%ebp), %mm0
	movq	232(%ebp), %mm1
	movq	240(%ebp), %mm2
	movq	248(%ebp), %mm3
	paddusw	224(%esi), %mm0
	paddusw	232(%esi), %mm1
	paddusw	240(%esi), %mm2
	paddusw	248(%esi), %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)

	movl	%ecx, %ebx
	movl	8(%esp), %esi
	movl	12(%esp), %ebp
	movl	16(%esp), %edi
	decl	%eax
	jnz	.mainad_nt

/* counter (finish); stack sanity enabled */
	movl	%esp, %ebx
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebx, %esp
/* free memory */
	movl	28(%esp), %eax
	movl	%eax, 0(%esp)
	call	_free
/* counter (base frequency); stack sanity enabled */
	movl	%esp, %ebx
	leal	24(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceFrequency@4
	movl	%ebx, %esp
/* time calculation (in milliseconds) */
	movl	24(%esp), %eax
	movl	28(%esp), %edx
	movl	$1000, %ecx
	divl	%ecx
	movl	%eax, %ecx
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	44(%esp), %edx
	sbbl	36(%esp), %edx
	divl	%ecx
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  _mmxtr_nt
_mmxtr_nt:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate memory; 4Kb page alignment enabled */
	movl	$0x00001000, %ebp
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebp, %ecx
	movl	%ecx, 0(%esp)
	call	_malloc
	movl	%eax, 28(%esp)
	addl	%ebp, %eax
	andw	$0xF000, %ax
	movl	%eax, %esi
	addl	%ebx, %eax
	movl	%eax, %ebp
	addl	%ebx, %eax
	movl	%eax, %edi
/* prefill */
	movl	$0x00210021, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm0
	movl	$0x00370037, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm1
	movl	%ebx, %ecx
	shrl	$5, %ecx
	movl	%esi, %edx
	movl	%ebp, %eax
.pretr_nt:
	movntq	%mm0, 0(%edx)
	movntq	%mm0, 8(%edx)
	movntq	%mm0, 16(%edx)
	movntq	%mm0, 24(%edx)
	movntq	%mm1, 0(%eax)
	movntq	%mm1, 8(%eax)
	movntq	%mm1, 16(%eax)
	movntq	%mm1, 24(%eax)
	addl	$32, %edx
	addl	$32, %eax
	loopl	.pretr_nt
/* counter (start); stack sanity enabled */
	movl	%esp, %ebx
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebx, %esp
/* create the multiplier */
	movw	$77, 8(%esp)
	movw	$77, 10(%esp)
	movw	$77, 12(%esp)
	movw	$77, 14(%esp)
	movq	8(%esp), %mm4
/* execute */
	movl	68(%esp), %ebx
	shll	$2, %ebx
	decl	%ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, 8(%esp)
	movl	%ebp, 12(%esp)
	movl	%edi, 16(%esp)
	movl	$256, %edx
.maintr_nt:
/* every loop prefetches the next one */
	prefetchnta	256(%ebp)
	prefetchnta	288(%ebp)
	movq	0(%ebp), %mm0
	movq	8(%ebp), %mm1
	movq	16(%ebp), %mm2
	movq	24(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	0(%esi), %mm0
	paddusw	8(%esi), %mm1
	paddusw	16(%esi), %mm2
	paddusw	24(%esi), %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	prefetchnta	256(%esi)
	prefetchnta	288(%esi)
	movq	32(%ebp), %mm0
	movq	40(%ebp), %mm1
	movq	48(%ebp), %mm2
	movq	56(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	32(%esi), %mm0
	paddusw	40(%esi), %mm1
	paddusw	48(%esi), %mm2
	paddusw	56(%esi), %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	prefetchnta	320(%ebp)
	prefetchnta	352(%ebp)
	movq	64(%ebp), %mm0
	movq	72(%ebp), %mm1
	movq	80(%ebp), %mm2
	movq	88(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	64(%esi), %mm0
	paddusw	72(%esi), %mm1
	paddusw	80(%esi), %mm2
	paddusw	88(%esi), %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	prefetchnta	320(%esi)
	prefetchnta	352(%esi)
	movq	96(%ebp), %mm0
	movq	104(%ebp), %mm1
	movq	112(%ebp), %mm2
	movq	120(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	96(%esi), %mm0
	paddusw	104(%esi), %mm1
	paddusw	112(%esi), %mm2
	paddusw	120(%esi), %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	prefetchnta	384(%ebp)
	prefetchnta	416(%ebp)
	movq	128(%ebp), %mm0
	movq	136(%ebp), %mm1
	movq	144(%ebp), %mm2
	movq	152(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	128(%esi), %mm0
	paddusw	136(%esi), %mm1
	paddusw	144(%esi), %mm2
	paddusw	152(%esi), %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	prefetchnta	384(%esi)
	prefetchnta	416(%esi)
	movq	160(%ebp), %mm0
	movq	168(%ebp), %mm1
	movq	176(%ebp), %mm2
	movq	184(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	160(%esi), %mm0
	paddusw	168(%esi), %mm1
	paddusw	176(%esi), %mm2
	paddusw	184(%esi), %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	prefetchnta	448(%ebp)
	prefetchnta	480(%ebp)
	movq	192(%ebp), %mm0
	movq	200(%ebp), %mm1
	movq	208(%ebp), %mm2
	movq	216(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	192(%esi), %mm0
	paddusw	200(%esi), %mm1
	paddusw	208(%esi), %mm2
	paddusw	216(%esi), %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	prefetchnta	448(%esi)
	prefetchnta	480(%esi)
	movq	224(%ebp), %mm0
	movq	232(%ebp), %mm1
	movq	240(%ebp), %mm2
	movq	248(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	224(%esi), %mm0
	paddusw	232(%esi), %mm1
	paddusw	240(%esi), %mm2
	paddusw	248(%esi), %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)
	addl	%edx, %esi
	addl	%edx, %ebp
	addl	%edx, %edi
	decl	%ebx
	jnz	.maintr_nt

/* the last loop of the memory block;
 * no more prefetches to avoid hidden page faults */
	movq	0(%ebp), %mm0
	movq	8(%ebp), %mm1
	movq	16(%ebp), %mm2
	movq	24(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	0(%esi), %mm0
	paddusw	8(%esi), %mm1
	paddusw	16(%esi), %mm2
	paddusw	24(%esi), %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	movq	32(%ebp), %mm0
	movq	40(%ebp), %mm1
	movq	48(%ebp), %mm2
	movq	56(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	32(%esi), %mm0
	paddusw	40(%esi), %mm1
	paddusw	48(%esi), %mm2
	paddusw	56(%esi), %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	movq	64(%ebp), %mm0
	movq	72(%ebp), %mm1
	movq	80(%ebp), %mm2
	movq	88(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	64(%esi), %mm0
	paddusw	72(%esi), %mm1
	paddusw	80(%esi), %mm2
	paddusw	88(%esi), %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	movq	96(%ebp), %mm0
	movq	104(%ebp), %mm1
	movq	112(%ebp), %mm2
	movq	120(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	96(%esi), %mm0
	paddusw	104(%esi), %mm1
	paddusw	112(%esi), %mm2
	paddusw	120(%esi), %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	movq	128(%ebp), %mm0
	movq	136(%ebp), %mm1
	movq	144(%ebp), %mm2
	movq	152(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	128(%esi), %mm0
	paddusw	136(%esi), %mm1
	paddusw	144(%esi), %mm2
	paddusw	152(%esi), %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	movq	160(%ebp), %mm0
	movq	168(%ebp), %mm1
	movq	176(%ebp), %mm2
	movq	184(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	160(%esi), %mm0
	paddusw	168(%esi), %mm1
	paddusw	176(%esi), %mm2
	paddusw	184(%esi), %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	movq	192(%ebp), %mm0
	movq	200(%ebp), %mm1
	movq	208(%ebp), %mm2
	movq	216(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	192(%esi), %mm0
	paddusw	200(%esi), %mm1
	paddusw	208(%esi), %mm2
	paddusw	216(%esi), %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	movq	224(%ebp), %mm0
	movq	232(%ebp), %mm1
	movq	240(%ebp), %mm2
	movq	248(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	224(%esi), %mm0
	paddusw	232(%esi), %mm1
	paddusw	240(%esi), %mm2
	paddusw	248(%esi), %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)

	movl	%ecx, %ebx
	movl	8(%esp), %esi
	movl	12(%esp), %ebp
	movl	16(%esp), %edi
	decl	%eax
	jnz	.maintr_nt

/* counter (finish); stack sanity enabled */
	movl	%esp, %ebx
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebx, %esp
/* free memory */
	movl	28(%esp), %eax
	movl	%eax, 0(%esp)
	call	_free
/* counter (base frequency); stack sanity enabled */
	movl	%esp, %ebx
	leal	24(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceFrequency@4
	movl	%ebx, %esp
/* time calculation (in milliseconds) */
	movl	24(%esp), %eax
	movl	28(%esp), %edx
	movl	$1000, %ecx
	divl	%ecx
	movl	%eax, %ecx
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	44(%esp), %edx
	sbbl	36(%esp), %edx
	divl	%ecx
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  _mmxcp_nt_t0
_mmxcp_nt_t0:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate memory; 4Kb page alignment enabled */
	movl	$0x00001000, %ebp
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebp, %ecx
	movl	%ecx, 0(%esp)
	call	_malloc
	movl	%eax, 28(%esp)
	addl	%ebp, %eax
	andw	$0xF000, %ax
	movl	%eax, %esi
	addl	%ebx, %eax
	movl	%eax, %edi
/* prefill */
	movl	$0x00210021, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm0
	movl	%ebx, %ecx
	shrl	$5, %ecx
	movl	%esi, %edx
.precp_nt_t0:
	movntq	%mm0, 0(%edx)
	movntq	%mm0, 8(%edx)
	movntq	%mm0, 16(%edx)
	movntq	%mm0, 24(%edx)
	addl	$32, %edx
	loopl	.precp_nt_t0
/* counter (start); stack sanity enabled */
	movl	%esp, %ebp
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebp, %esp
/* execute */
	shrl	$8, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, %edx
	movl	%edi, %ebp
.maincp_nt_t0:
/* every loop prefetches the next one */
	prefetcht0	256(%esi)
	prefetcht0	288(%esi)
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	prefetcht0	320(%esi)
	prefetcht0	352(%esi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	prefetcht0	384(%esi)
	prefetcht0	416(%esi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	prefetcht0	448(%esi)
	prefetcht0	480(%esi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)
	addl	$256, %esi
	addl	$256, %edi
	decl	%ebx
	jnz	.maincp_nt_t0

/* the last loop of the memory block;
 * no more prefetches to avoid hidden page faults */
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)

	movl	%ecx, %ebx
	movl	%edx, %esi
	movl	%ebp, %edi
	decl	%eax
	jnz	.maincp_nt_t0

/* counter (finish); stack sanity enabled */
	movl	%esp, %ebp
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebp, %esp
/* free memory */
	movl	28(%esp), %eax
	movl	%eax, 0(%esp)
	call	_free
/* counter (base frequency); stack sanity enabled */
	movl	%esp, %ebp
	leal	24(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceFrequency@4
	movl	%ebp, %esp
/* time calculation (in milliseconds) */
	movl	24(%esp), %eax
	movl	28(%esp), %edx
	movl	$1000, %ecx
	divl	%ecx
	movl	%eax, %ecx
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	44(%esp), %edx
	sbbl	36(%esp), %edx
	divl	%ecx
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  _mmxsc_nt_t0
_mmxsc_nt_t0:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate memory; 4Kb page alignment enabled */
	movl	$0x00001000, %ebp
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebp, %ecx
	movl	%ecx, 0(%esp)
	call	_malloc
	movl	%eax, 28(%esp)
	addl	%ebp, %eax
	andw	$0xF000, %ax
	movl	%eax, %esi
	addl	%ebx, %eax
	movl	%eax, %edi
/* prefill */
	movl	$0x00210021, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm0
	movl	%ebx, %ecx
	shrl	$5, %ecx
	movl	%esi, %edx
.presc_nt_t0:
	movntq	%mm0, 0(%edx)
	movntq	%mm0, 8(%edx)
	movntq	%mm0, 16(%edx)
	movntq	%mm0, 24(%edx)
	addl	$32, %edx
	loopl	.presc_nt_t0
/* counter (start); stack sanity enabled */
	movl	%esp, %ebp
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebp, %esp
/* create the multiplier */
	movw	$77, 8(%esp)
	movw	$77, 10(%esp)
	movw	$77, 12(%esp)
	movw	$77, 14(%esp)
	movq	8(%esp), %mm4
/* execute */
	shrl	$8, %ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, %edx
	movl	%edi, %ebp
.mainsc_nt_t0:
/* every loop prefetches the next one */
	prefetcht0	256(%esi)
	prefetcht0	288(%esi)
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	prefetcht0	320(%esi)
	prefetcht0	352(%esi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	prefetcht0	384(%esi)
	prefetcht0	416(%esi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	prefetcht0	448(%esi)
	prefetcht0	480(%esi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)
	addl	$256, %esi
	addl	$256, %edi
	decl	%ebx
	jnz	.mainsc_nt_t0

/* the last loop of the memory block;
 * no more prefetches to avoid hidden page faults */
	movq	0(%esi), %mm0
	movq	8(%esi), %mm1
	movq	16(%esi), %mm2
	movq	24(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	movq	32(%esi), %mm0
	movq	40(%esi), %mm1
	movq	48(%esi), %mm2
	movq	56(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	movq	64(%esi), %mm0
	movq	72(%esi), %mm1
	movq	80(%esi), %mm2
	movq	88(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	movq	96(%esi), %mm0
	movq	104(%esi), %mm1
	movq	112(%esi), %mm2
	movq	120(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	movq	128(%esi), %mm0
	movq	136(%esi), %mm1
	movq	144(%esi), %mm2
	movq	152(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	movq	160(%esi), %mm0
	movq	168(%esi), %mm1
	movq	176(%esi), %mm2
	movq	184(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	movq	192(%esi), %mm0
	movq	200(%esi), %mm1
	movq	208(%esi), %mm2
	movq	216(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	movq	224(%esi), %mm0
	movq	232(%esi), %mm1
	movq	240(%esi), %mm2
	movq	248(%esi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)

	movl	%ecx, %ebx
	movl	%edx, %esi
	movl	%ebp, %edi
	decl	%eax
	jnz	.mainsc_nt_t0

/* counter (finish); stack sanity enabled */
	movl	%esp, %ebp
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebp, %esp
/* free memory */
	movl	28(%esp), %eax
	movl	%eax, 0(%esp)
	call	_free
/* counter (base frequency); stack sanity enabled */
	movl	%esp, %ebp
	leal	24(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceFrequency@4
	movl	%ebp, %esp
/* time calculation (in milliseconds) */
	movl	24(%esp), %eax
	movl	28(%esp), %edx
	movl	$1000, %ecx
	divl	%ecx
	movl	%eax, %ecx
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	44(%esp), %edx
	sbbl	36(%esp), %edx
	divl	%ecx
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  _mmxad_nt_t0
_mmxad_nt_t0:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate memory; 4Kb page alignment enabled */
	movl	$0x00001000, %ebp
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebp, %ecx
	movl	%ecx, 0(%esp)
	call	_malloc
	movl	%eax, 28(%esp)
	addl	%ebp, %eax
	andw	$0xF000, %ax
	movl	%eax, %esi
	addl	%ebx, %eax
	movl	%eax, %ebp
	addl	%ebx, %eax
	movl	%eax, %edi
/* prefill */
	movl	$0x00210021, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm0
	movl	$0x00370037, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm1
	movl	%ebx, %ecx
	shrl	$5, %ecx
	movl	%esi, %edx
	movl	%ebp, %eax
.pread_nt_t0:
	movntq	%mm0, 0(%edx)
	movntq	%mm0, 8(%edx)
	movntq	%mm0, 16(%edx)
	movntq	%mm0, 24(%edx)
	movntq	%mm1, 0(%eax)
	movntq	%mm1, 8(%eax)
	movntq	%mm1, 16(%eax)
	movntq	%mm1, 24(%eax)
	addl	$32, %edx
	addl	$32, %eax
	loopl	.pread_nt_t0
/* counter (start); stack sanity enabled */
	movl	%esp, %ebx
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebx, %esp
/* execute */
	movl	68(%esp), %ebx
	shll	$2, %ebx
	decl	%ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, 8(%esp)
	movl	%ebp, 12(%esp)
	movl	%edi, 16(%esp)
	movl	$256, %edx
.mainad_nt_t0:
/* every loop prefetches the next one */
	prefetcht0	256(%ebp)
	prefetcht0	288(%ebp)
	movq	0(%ebp), %mm0
	movq	8(%ebp), %mm1
	movq	16(%ebp), %mm2
	movq	24(%ebp), %mm3
	paddusw	0(%esi), %mm0
	paddusw	8(%esi), %mm1
	paddusw	16(%esi), %mm2
	paddusw	24(%esi), %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	prefetcht0	256(%esi)
	prefetcht0	288(%esi)
	movq	32(%ebp), %mm0
	movq	40(%ebp), %mm1
	movq	48(%ebp), %mm2
	movq	56(%ebp), %mm3
	paddusw	32(%esi), %mm0
	paddusw	40(%esi), %mm1
	paddusw	48(%esi), %mm2
	paddusw	56(%esi), %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	prefetcht0	320(%ebp)
	prefetcht0	352(%ebp)
	movq	64(%ebp), %mm0
	movq	72(%ebp), %mm1
	movq	80(%ebp), %mm2
	movq	88(%ebp), %mm3
	paddusw	64(%esi), %mm0
	paddusw	72(%esi), %mm1
	paddusw	80(%esi), %mm2
	paddusw	88(%esi), %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	prefetcht0	320(%esi)
	prefetcht0	352(%esi)
	movq	96(%ebp), %mm0
	movq	104(%ebp), %mm1
	movq	112(%ebp), %mm2
	movq	120(%ebp), %mm3
	paddusw	96(%esi), %mm0
	paddusw	104(%esi), %mm1
	paddusw	112(%esi), %mm2
	paddusw	120(%esi), %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	prefetcht0	384(%ebp)
	prefetcht0	416(%ebp)
	movq	128(%ebp), %mm0
	movq	136(%ebp), %mm1
	movq	144(%ebp), %mm2
	movq	152(%ebp), %mm3
	paddusw	128(%esi), %mm0
	paddusw	136(%esi), %mm1
	paddusw	144(%esi), %mm2
	paddusw	152(%esi), %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	prefetcht0	384(%esi)
	prefetcht0	416(%esi)
	movq	160(%ebp), %mm0
	movq	168(%ebp), %mm1
	movq	176(%ebp), %mm2
	movq	184(%ebp), %mm3
	paddusw	160(%esi), %mm0
	paddusw	168(%esi), %mm1
	paddusw	176(%esi), %mm2
	paddusw	184(%esi), %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	prefetcht0	448(%ebp)
	prefetcht0	480(%ebp)
	movq	192(%ebp), %mm0
	movq	200(%ebp), %mm1
	movq	208(%ebp), %mm2
	movq	216(%ebp), %mm3
	paddusw	192(%esi), %mm0
	paddusw	200(%esi), %mm1
	paddusw	208(%esi), %mm2
	paddusw	216(%esi), %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	prefetcht0	448(%esi)
	prefetcht0	480(%esi)
	movq	224(%ebp), %mm0
	movq	232(%ebp), %mm1
	movq	240(%ebp), %mm2
	movq	248(%ebp), %mm3
	paddusw	224(%esi), %mm0
	paddusw	232(%esi), %mm1
	paddusw	240(%esi), %mm2
	paddusw	248(%esi), %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)
	addl	%edx, %esi
	addl	%edx, %ebp
	addl	%edx, %edi
	decl	%ebx
	jnz	.mainad_nt_t0

/* the last loop of the memory block;
 * no more prefetches to avoid hidden page faults */
	movq	0(%ebp), %mm0
	movq	8(%ebp), %mm1
	movq	16(%ebp), %mm2
	movq	24(%ebp), %mm3
	paddusw	0(%esi), %mm0
	paddusw	8(%esi), %mm1
	paddusw	16(%esi), %mm2
	paddusw	24(%esi), %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	movq	32(%ebp), %mm0
	movq	40(%ebp), %mm1
	movq	48(%ebp), %mm2
	movq	56(%ebp), %mm3
	paddusw	32(%esi), %mm0
	paddusw	40(%esi), %mm1
	paddusw	48(%esi), %mm2
	paddusw	56(%esi), %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	movq	64(%ebp), %mm0
	movq	72(%ebp), %mm1
	movq	80(%ebp), %mm2
	movq	88(%ebp), %mm3
	paddusw	64(%esi), %mm0
	paddusw	72(%esi), %mm1
	paddusw	80(%esi), %mm2
	paddusw	88(%esi), %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	movq	96(%ebp), %mm0
	movq	104(%ebp), %mm1
	movq	112(%ebp), %mm2
	movq	120(%ebp), %mm3
	paddusw	96(%esi), %mm0
	paddusw	104(%esi), %mm1
	paddusw	112(%esi), %mm2
	paddusw	120(%esi), %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	movq	128(%ebp), %mm0
	movq	136(%ebp), %mm1
	movq	144(%ebp), %mm2
	movq	152(%ebp), %mm3
	paddusw	128(%esi), %mm0
	paddusw	136(%esi), %mm1
	paddusw	144(%esi), %mm2
	paddusw	152(%esi), %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	movq	160(%ebp), %mm0
	movq	168(%ebp), %mm1
	movq	176(%ebp), %mm2
	movq	184(%ebp), %mm3
	paddusw	160(%esi), %mm0
	paddusw	168(%esi), %mm1
	paddusw	176(%esi), %mm2
	paddusw	184(%esi), %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	movq	192(%ebp), %mm0
	movq	200(%ebp), %mm1
	movq	208(%ebp), %mm2
	movq	216(%ebp), %mm3
	paddusw	192(%esi), %mm0
	paddusw	200(%esi), %mm1
	paddusw	208(%esi), %mm2
	paddusw	216(%esi), %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	movq	224(%ebp), %mm0
	movq	232(%ebp), %mm1
	movq	240(%ebp), %mm2
	movq	248(%ebp), %mm3
	paddusw	224(%esi), %mm0
	paddusw	232(%esi), %mm1
	paddusw	240(%esi), %mm2
	paddusw	248(%esi), %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)

	movl	%ecx, %ebx
	movl	8(%esp), %esi
	movl	12(%esp), %ebp
	movl	16(%esp), %edi
	decl	%eax
	jnz	.mainad_nt_t0

/* counter (finish); stack sanity enabled */
	movl	%esp, %ebx
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebx, %esp
/* free memory */
	movl	28(%esp), %eax
	movl	%eax, 0(%esp)
	call	_free
/* counter (base frequency); stack sanity enabled */
	movl	%esp, %ebx
	leal	24(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceFrequency@4
	movl	%ebx, %esp
/* time calculation (in milliseconds) */
	movl	24(%esp), %eax
	movl	28(%esp), %edx
	movl	$1000, %ecx
	divl	%ecx
	movl	%eax, %ecx
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	44(%esp), %edx
	sbbl	36(%esp), %edx
	divl	%ecx
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret

.globl  _mmxtr_nt_t0
_mmxtr_nt_t0:
/* set up the stack frame */
	pushl	%ebx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	subl	$48, %esp
/* allocate memory; 4Kb page alignment enabled */
	movl	$0x00001000, %ebp
	movl	68(%esp), %ebx
	shll	$10, %ebx
	movl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebx, %ecx
	addl	%ebp, %ecx
	movl	%ecx, 0(%esp)
	call	_malloc
	movl	%eax, 28(%esp)
	addl	%ebp, %eax
	andw	$0xF000, %ax
	movl	%eax, %esi
	addl	%ebx, %eax
	movl	%eax, %ebp
	addl	%ebx, %eax
	movl	%eax, %edi
/* prefill */
	movl	$0x00210021, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm0
	movl	$0x00370037, %eax
	movl	%eax, 0(%esp)
	movl	%eax, 4(%esp)
	movq	0(%esp), %mm1
	movl	%ebx, %ecx
	shrl	$5, %ecx
	movl	%esi, %edx
	movl	%ebp, %eax
.pretr_nt_t0:
	movntq	%mm0, 0(%edx)
	movntq	%mm0, 8(%edx)
	movntq	%mm0, 16(%edx)
	movntq	%mm0, 24(%edx)
	movntq	%mm1, 0(%eax)
	movntq	%mm1, 8(%eax)
	movntq	%mm1, 16(%eax)
	movntq	%mm1, 24(%eax)
	addl	$32, %edx
	addl	$32, %eax
	loopl	.pretr_nt_t0
/* counter (start); stack sanity enabled */
	movl	%esp, %ebx
	leal	32(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebx, %esp
/* create the multiplier */
	movw	$77, 8(%esp)
	movw	$77, 10(%esp)
	movw	$77, 12(%esp)
	movw	$77, 14(%esp)
	movq	8(%esp), %mm4
/* execute */
	movl	68(%esp), %ebx
	shll	$2, %ebx
	decl	%ebx
	movl	%ebx, %ecx
	movl	72(%esp), %eax
	movl	%esi, 8(%esp)
	movl	%ebp, 12(%esp)
	movl	%edi, 16(%esp)
	movl	$256, %edx
.maintr_nt_t0:
/* every loop prefetches the next one */
	prefetcht0	256(%ebp)
	prefetcht0	288(%ebp)
	movq	0(%ebp), %mm0
	movq	8(%ebp), %mm1
	movq	16(%ebp), %mm2
	movq	24(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	0(%esi), %mm0
	paddusw	8(%esi), %mm1
	paddusw	16(%esi), %mm2
	paddusw	24(%esi), %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	prefetcht0	256(%esi)
	prefetcht0	288(%esi)
	movq	32(%ebp), %mm0
	movq	40(%ebp), %mm1
	movq	48(%ebp), %mm2
	movq	56(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	32(%esi), %mm0
	paddusw	40(%esi), %mm1
	paddusw	48(%esi), %mm2
	paddusw	56(%esi), %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	prefetcht0	320(%ebp)
	prefetcht0	352(%ebp)
	movq	64(%ebp), %mm0
	movq	72(%ebp), %mm1
	movq	80(%ebp), %mm2
	movq	88(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	64(%esi), %mm0
	paddusw	72(%esi), %mm1
	paddusw	80(%esi), %mm2
	paddusw	88(%esi), %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	prefetcht0	320(%esi)
	prefetcht0	352(%esi)
	movq	96(%ebp), %mm0
	movq	104(%ebp), %mm1
	movq	112(%ebp), %mm2
	movq	120(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	96(%esi), %mm0
	paddusw	104(%esi), %mm1
	paddusw	112(%esi), %mm2
	paddusw	120(%esi), %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	prefetcht0	384(%ebp)
	prefetcht0	416(%ebp)
	movq	128(%ebp), %mm0
	movq	136(%ebp), %mm1
	movq	144(%ebp), %mm2
	movq	152(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	128(%esi), %mm0
	paddusw	136(%esi), %mm1
	paddusw	144(%esi), %mm2
	paddusw	152(%esi), %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	prefetcht0	384(%esi)
	prefetcht0	416(%esi)
	movq	160(%ebp), %mm0
	movq	168(%ebp), %mm1
	movq	176(%ebp), %mm2
	movq	184(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	160(%esi), %mm0
	paddusw	168(%esi), %mm1
	paddusw	176(%esi), %mm2
	paddusw	184(%esi), %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	prefetcht0	448(%ebp)
	prefetcht0	480(%ebp)
	movq	192(%ebp), %mm0
	movq	200(%ebp), %mm1
	movq	208(%ebp), %mm2
	movq	216(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	192(%esi), %mm0
	paddusw	200(%esi), %mm1
	paddusw	208(%esi), %mm2
	paddusw	216(%esi), %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	prefetcht0	448(%esi)
	prefetcht0	480(%esi)
	movq	224(%ebp), %mm0
	movq	232(%ebp), %mm1
	movq	240(%ebp), %mm2
	movq	248(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	224(%esi), %mm0
	paddusw	232(%esi), %mm1
	paddusw	240(%esi), %mm2
	paddusw	248(%esi), %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)
	addl	%edx, %esi
	addl	%edx, %ebp
	addl	%edx, %edi
	decl	%ebx
	jnz	.maintr_nt_t0

/* the last loop of the memory block;
 * no more prefetches to avoid hidden page faults */
	movq	0(%ebp), %mm0
	movq	8(%ebp), %mm1
	movq	16(%ebp), %mm2
	movq	24(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	0(%esi), %mm0
	paddusw	8(%esi), %mm1
	paddusw	16(%esi), %mm2
	paddusw	24(%esi), %mm3
	movntq	%mm0, 0(%edi)
	movntq	%mm1, 8(%edi)
	movntq	%mm2, 16(%edi)
	movntq	%mm3, 24(%edi)
	movq	32(%ebp), %mm0
	movq	40(%ebp), %mm1
	movq	48(%ebp), %mm2
	movq	56(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	32(%esi), %mm0
	paddusw	40(%esi), %mm1
	paddusw	48(%esi), %mm2
	paddusw	56(%esi), %mm3
	movntq	%mm0, 32(%edi)
	movntq	%mm1, 40(%edi)
	movntq	%mm2, 48(%edi)
	movntq	%mm3, 56(%edi)
	movq	64(%ebp), %mm0
	movq	72(%ebp), %mm1
	movq	80(%ebp), %mm2
	movq	88(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	64(%esi), %mm0
	paddusw	72(%esi), %mm1
	paddusw	80(%esi), %mm2
	paddusw	88(%esi), %mm3
	movntq	%mm0, 64(%edi)
	movntq	%mm1, 72(%edi)
	movntq	%mm2, 80(%edi)
	movntq	%mm3, 88(%edi)
	movq	96(%ebp), %mm0
	movq	104(%ebp), %mm1
	movq	112(%ebp), %mm2
	movq	120(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	96(%esi), %mm0
	paddusw	104(%esi), %mm1
	paddusw	112(%esi), %mm2
	paddusw	120(%esi), %mm3
	movntq	%mm0, 96(%edi)
	movntq	%mm1, 104(%edi)
	movntq	%mm2, 112(%edi)
	movntq	%mm3, 120(%edi)
	movq	128(%ebp), %mm0
	movq	136(%ebp), %mm1
	movq	144(%ebp), %mm2
	movq	152(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	128(%esi), %mm0
	paddusw	136(%esi), %mm1
	paddusw	144(%esi), %mm2
	paddusw	152(%esi), %mm3
	movntq	%mm0, 128(%edi)
	movntq	%mm1, 136(%edi)
	movntq	%mm2, 144(%edi)
	movntq	%mm3, 152(%edi)
	movq	160(%ebp), %mm0
	movq	168(%ebp), %mm1
	movq	176(%ebp), %mm2
	movq	184(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	160(%esi), %mm0
	paddusw	168(%esi), %mm1
	paddusw	176(%esi), %mm2
	paddusw	184(%esi), %mm3
	movntq	%mm0, 160(%edi)
	movntq	%mm1, 168(%edi)
	movntq	%mm2, 176(%edi)
	movntq	%mm3, 184(%edi)
	movq	192(%ebp), %mm0
	movq	200(%ebp), %mm1
	movq	208(%ebp), %mm2
	movq	216(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	192(%esi), %mm0
	paddusw	200(%esi), %mm1
	paddusw	208(%esi), %mm2
	paddusw	216(%esi), %mm3
	movntq	%mm0, 192(%edi)
	movntq	%mm1, 200(%edi)
	movntq	%mm2, 208(%edi)
	movntq	%mm3, 216(%edi)
	movq	224(%ebp), %mm0
	movq	232(%ebp), %mm1
	movq	240(%ebp), %mm2
	movq	248(%ebp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	224(%esi), %mm0
	paddusw	232(%esi), %mm1
	paddusw	240(%esi), %mm2
	paddusw	248(%esi), %mm3
	movntq	%mm0, 224(%edi)
	movntq	%mm1, 232(%edi)
	movntq	%mm2, 240(%edi)
	movntq	%mm3, 248(%edi)

	movl	%ecx, %ebx
	movl	8(%esp), %esi
	movl	12(%esp), %ebp
	movl	16(%esp), %edi
	decl	%eax
	jnz	.maintr_nt_t0

/* counter (finish); stack sanity enabled */
	movl	%esp, %ebx
	leal	40(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceCounter@4
	movl	%ebx, %esp
/* free memory */
	movl	28(%esp), %eax
	movl	%eax, 0(%esp)
	call	_free
/* counter (base frequency); stack sanity enabled */
	movl	%esp, %ebx
	leal	24(%esp), %eax
	movl	%eax, 0(%esp)
	call	_QueryPerformanceFrequency@4
	movl	%ebx, %esp
/* time calculation (in milliseconds) */
	movl	24(%esp), %eax
	movl	28(%esp), %edx
	movl	$1000, %ecx
	divl	%ecx
	movl	%eax, %ecx
	movl	40(%esp), %eax
	subl	32(%esp), %eax
	movl	44(%esp), %edx
	sbbl	36(%esp), %edx
	divl	%ecx
/* restore and return */
	emms
	addl	$48, %esp
	popl	%edi
	popl	%esi
	popl	%ebp
	popl	%ebx
	ret
